﻿Imports System.Threading

Module Module1

    Private ObjLockA As Object = New Object()
    Private ObjLockB As Object = New Object()

    Sub Main()
        Console.WriteLine("----Exemplo de DeadLock-----")
        Console.WriteLine()

        ' Inicializa a thread com endereço Tarefa1
        Dim thread1 As New Thread(AddressOf Tarefa1)

        ' Inicializa a thread com endereço Tarefa2
        Dim thread2 As New Thread(AddressOf Tarefa2)

        ' Agenda a execução das threads
        thread1.Start()
        thread2.Start()

        thread1.Join()
        thread2.Join()

        ' Esta instrução nunca será executada
        Console.WriteLine("Processamento concluído...")
        Console.ReadKey()
    End Sub

    'Private Sub Tarefa1()
    '    SyncLock ObjLockA
    '        Console.WriteLine("Tentando adquirir um bloqueio em ObjLockB")

    '        ' Pausa de 1 segundo
    '        Thread.Sleep(1000)
    '        SyncLock ObjLockB
    '            ' Este bloco nunca será executado
    '            Console.WriteLine("Em Tarefa1 - Seção Crítica.")
    '            ' Acesso ao recurso compartilhado
    '        End SyncLock
    '    End SyncLock
    'End Sub

    Private Sub Tarefa1()
        SyncLock ObjLockA
            Console.WriteLine("Tentando adquirir um bloqueio em ObjLockB")

            ' Pausa de 1 segundo
            Thread.Sleep(1000)

            ' Tenta adquirir um bloqueio por 5 segundos
            If Monitor.TryEnter(ObjLockB, 5000) Then
                Try
                    ' Este bloco nunca será executado
                    Console.WriteLine("Tarefa1 - Seção Crítica.")
                    ' Acesso ao recurso compartilhado
                Finally
                    Monitor.[Exit](ObjLockB)
                End Try
            Else
                Console.WriteLine("Não foi possível adquirir um bloqueio, saindo de Tarefa1...")
            End If
        End SyncLock
    End Sub


    Private Sub Tarefa2()
        SyncLock ObjLockB
            Console.WriteLine("Tentando adquirir um bloqueio em ObjLockA")
            SyncLock ObjLockA
                ' Este bloco de código nunca será executado
                ' Acesso ao recurso compartilhado
                Console.WriteLine("Tarefa2 - Seção Crítica")
            End SyncLock
        End SyncLock
    End Sub

End Module
